﻿-- Author      : Zaultar
-- Create Date : 11/27/2008 10:17:49 PM
-- _O1_ OnLoad()
-- _02_ OnEvent()

-- Addon constants
CN_NAME 	= "Chat Notes"
CN_VNMBR	= 400001			-- Number code for this version

-- Colors
CN_HELP_COLOR		= "|cFFFFFF7F"
CN_ERROR_COLOR	    = "|cFFFF0000"
CN_UNKNOWN_COLOR	= "|cFF7F7F7F"
CN_TOKEN_COLOR	    = "|cFFFF0000"
CN_NORMAL_COLOR     = "|r"

CN_NOTE_COLOR       = "|cFFFFFF7F"   -- Chat Note
CN_FRIEND_COLOR     = "|cFFE5B200"   -- Neutral
CN_GUILD_COLOR      = "|cFF00FF00"   -- or lighter green "|cFFC0FFC0"

-- Stored Data
if not CN_State then CN_State = {} end		-- Data saved between sessions
if not CN_Notes then CN_Notes = {} end		-- Names database
if not CN_FNotes then CN_FNotes = {} end	-- Friend Notes database
if not CN_GNotes then CN_GNotes = {} end	-- Guild Notes database
if not CN_FData then CN_FData = {} end		-- Friend Data (level, class zone)
if not CN_GData then CN_GData = {} end		-- Friend Data (level, class zone)

-- Slash variables
local SLASH_ON = "on";			-- Enabled Chat Notes? (really?)
local SLASH_OFF = "off";		-- Enabled Chat Notes? (really?)
local SLASH_ADD = "add"			-- Add a player note
local SLASH_WHO = "whois"		-- Whois a user
local SLASH_COLOR = "color"		-- Toggles Color on/off
local SLASH_DEBUG = "debug";	-- Toggles Debug output on/off
local SLASH_STATUS = "status";  -- Displays current settings
local SLASH_FRIENDS = "friends";-- Dump friends notes into array
local SLASH_GUILD = "guild";    -- Dump friends notes into array

local CN_Global_Name = "";
local CN_Global_Note = "";


-- _01_ OnLoad() Handler	
------------------------------------------------------------
function ChatNotes_OnLoad(self) 
--	self:RegisterEvent("SYSTEM");
	self:RegisterEvent("ADDON_LOADED");
--	self:RegisterEvent("PLAYER_ENTERING_WORLD");
--	self:RegisterEvent("GUILD_REGISTRAR_SHOW");
	self:RegisterEvent("FRIENDLIST_UPDATE");
	self:RegisterEvent("GUILD_ROSTER_UPDATE");
	self:RegisterEvent("VARIABLES_LOADED");
	
	SLASH_CHATNOTES1 = "/chatnotes"
	SLASH_CHATNOTES2 = "/cn"
	SlashCmdList["CHATNOTES"] = CN_ParseSlash;
	
	SLASH_WHOIS1 = "/whois"
	SlashCmdList["WHOIS"] = CN_WhoPlayer;

	SLASH_ADD1 = "/add"
	SlashCmdList["ADD"] = CN_AddCommand;
	
	DEFAULT_CHAT_FRAME:AddMessage(CN_HELP_COLOR..CN_NAME..":|r "..CN_TXT.loaded..CN_HELP_COLOR..CN_TXT.loadedtext);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", CN_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", CN_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", CN_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", CN_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", CN_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", CN_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", CN_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", CN_ChatFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", CN_ChatFilter)
	
	-- use ChatFilter_System (a copy of ChatFilter) so we can see if we see strings without account names.
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", CN_ChatFilter_System)

	-- Chat Frame Menu to add/remove
	UnitPopupMenus["CHATNOTES"] = {"CHATNOTES_ADD", "CHATNOTES_REMOVE", "CANCEL"};
	UnitPopupButtons["CHATNOTES"] = { text = CN_MENU_MAIN, dist = 0, nested = 1};
	UnitPopupButtons["CHATNOTES_ADD"] = { text = CN_MENU_ADD, dist = 0,};
	UnitPopupButtons["CHATNOTES_REMOVE"] = { text = CN_MENU_REMOVE, dist = 0 };

	table.insert(UnitPopupMenus["PLAYER"], #UnitPopupMenus["PLAYER"]-1, "CHATNOTES");
	table.insert(UnitPopupMenus["FRIEND"], #UnitPopupMenus["FRIEND"]-1, "CHATNOTES");
	table.insert(UnitPopupMenus["PARTY"], #UnitPopupMenus["PARTY"]-1, "CHATNOTES");

	hooksecurefunc("UnitPopup_OnClick", CN_UnitPopupOnClick);
	-- REMOVED 10-18-2010
	--hooksecurefunc("UnitPopup_HideButtons", CN_UnitPopupHideButtons);
	
	-- Static PopUp Dialogs
	StaticPopups();
end

function StaticPopups(self)
	-- You have you are removing a player's Chat Note
   	StaticPopupDialogs["CHATNOTE_POPUP_REMOVE"] = {
--		text = CN_TXT.removenote.."%s",
		text = "Are you sure you want to REMOVE the Chat Note for (%s)",
		button1 = TEXT(YES),
		button2 = TEXT(NO),
		OnAccept = function(data)
			data = CN_Global_Name
		    if (data) then 
--				CN_Debug("Data: "..data); 
				if (CN_Notes[data]) then
					CN_Notes[data] = nil
					CN_Debug("("..data..") Chat Note REMOVED")
				else
					CN_Debug("("..data..") Doesn't exist in CN_Notes")
				end
			end
		end,
		OnHide = function(data)
		end,
		whileDead = 1;
		timeout = 30;
		hideOnEscape = 1
	};
	-- Add or Modify a players existing Chat Note
   	StaticPopupDialogs["CHATNOTE_POPUP_ADDMODIFY"] = {
		text = "Set Chat Note for player (%s)",
		button1 = TEXT(YES),
		button2 = TEXT(NO),
		OnShow = function(self)
	--		if (CN_Global_Note) then getglobal(self:GetName().."EditBox"):SetText(CN_Global_Note) end
			if (CN_Global_Note) then self.editBox:SetText(CN_Global_Note) end
			--getglobal(self:GetName().."EditBox"):SetFocus()
		end,
        	OnAccept = function(self, data)
			local player = CN_Global_Name
			local note = nil
			note = self.editBox:GetText()
			-- Set a blank to a nil to erase value
			if (note == "") then note = nil end
			if (note) then
				CN_Notes[player] = note
			    CN_Debug("Added Note for ["..player.."] ("..note..")");
			end
--			if (self.editBox:GetText()) then CN_Debug("Data Name:"..self.editBox:GetText()) end
		end,
		OnHide = function(data)
		    CN_Debug("OnHide:");
		end,
        	EditBoxOnEnterPressed = function(self)
			local player = CN_Global_Name
			local note = nil
			note = self:GetText()
			-- Set a blank to a nil to erase value
			if (note == "") then note = nil end
			if (note) then
				CN_Notes[player] = note
--		    CN_Debug("Added Note for ["..player.."] ("..note..")");
			end
			CN_Debug("Enter Pressed")
			self:GetParent():Hide();
        	end,
    		EditBoxOnEscapePressed = function (self)
        		self:GetParent():Hide();
    		end,		
		whileDead = 1,
		timeout = 0,
		exclusive = 1,
		hideOnEscape = 1,
		--enterClicksFirstButton = 1,
		--sound = "levelup2"
		hasEditBox = 1
		--maxLetters = 32
	};
end

-- PopUp Menu on chat frame
function CN_UnitPopupOnClick(self)
	local dropdownFrame = UIDROPDOWNMENU_INIT_MENU;
	local button = self.value;
	local name = dropdownFrame.name;
	
	if button == "CHATNOTES_ADD" then
	    CN_Debug ("CHATNOTES_ADD Name:"..name);
	    CN_Global_Name = name
	    if (CN_Notes[name]) then
			CN_Global_Note = CN_Notes[name]
		else
			CN_Global_Note = ""
		end
	    local dialog = StaticPopup_Show("CHATNOTE_POPUP_ADDMODIFY", name);
		if dialog then dialog.data = name end
	    CN_Debug ("CHATNOTES_ADD  Name:"..name);
	    ToggleDropDownMenu(1, nil, dropdownFrame, "cursor");
	elseif button == "CHATNOTES_REMOVE" then
--	    CN_Debug ("CHATNOTES_REMOVE  Name:"..name);
		-- Set the name to pass in, since we can't seem to figure out the parameters
	    CN_Global_Name = name
	    local dialog = StaticPopup_Show("CHATNOTE_POPUP_REMOVE", name);
		if dialog then dialog.data = name end
--	    CN_Debug ("CHATNOTES_REMOVE  Name:"..name);
	    ToggleDropDownMenu(1, nil, dropdownFrame, "cursor");
	elseif button == "CANCEL" then
	    ToggleDropDownMenu(1, nil, dropdownFrame, "cursor");
	end

	return;
end


--[[ UnitPopupHideButtons : Hooked function to hide buttons on a RB popup for non-friendly players. ]]--
--function CN_UnitPopupHideButtons()
--	local dropdownFrame = getglobal(UIDROPDOWNMENU_INIT_MENU);
-- Fix for 3.0.8 change
-- REMOVING 10/18/2010 - not sure why this is in here
--	local dropdownFrame = UIDROPDOWNMENU_INIT_MENU;
--	local coop = dropdownFrame.unit and UnitCanCooperate("player", dropdownFrame.unit)
--	for index, value in ipairs(UnitPopupMenus[dropdownFrame.which]) do
--		if (value == "RECIPEBOOK_SHARE" and not coop) then
--			CN_Debug("CN_UnitPopupHideButtons")
--		    UnitPopupShown[UIDROPDOWNMENU_MENU_LEVEL][index] = 0;
--			return;
--		end
--	end
-- end


-- Filter Chat input and add our note to the begining of the string.
--function CN_ChatFilter(msg)
function CN_ChatFilter(self,event,msg,author, ...)
	local output = nil
	local note = ""
	if (CN_Notes[author] ) then
		if (CN_State.color) then output = CN_NOTE_COLOR else output = "" end
		note = CN_Notes[author];
	elseif (CN_FNotes[author] ) then
		if (CN_State.color) then output = CN_FRIEND_COLOR else output = "" end
		note = CN_FNotes[author];
	elseif (CN_GNotes[author] ) then
		if (CN_State.enabled) then
			if (CN_State.color) then output = CN_GUILD_COLOR else output = "" end
			note = CN_GNotes[author];
		end
	end

	-- If we have set anything in output, then we know to output our text
	if (output) then
--		return false, output.."("..note..") "..CN_NORMAL_COLOR..msg
   	   msg = output.."("..note..") "..CN_NORMAL_COLOR..tostring(msg)
	   return false, msg,author, ...
	end
end


-- Filter Chat input and add our note to the begining of the string.
--function CN_ChatFilter_System(msg)
function CN_ChatFilter_System(self,event,msg,...)
	local output = nil
	local note = ""
	local playername = "";
	local playernotes = nil;
	local playerdata = nil;

	-- For system messages fire and set msg to full string, with name inside

	-- <name> has gone offline.  (sys_goneoffline)
	if (string.find(msg, CN_TXT.sys_goneoffline)) then
	   playername = string.sub(msg, 1, string.find(msg, " ")-1)
	   --CN_Debug("<"..playername..">");
	   
	   if (CN_GNotes[playername]) then playernotes = CN_GNotes[playername]; end
	   if (CN_FNotes[playername]) then playernotes = CN_FNotes[playername]; end
	   if (CN_Notes[playername]) then playernotes = CN_Notes[playername]; end
	   
	   if (CN_GData[playername]) then playerdata = CN_GData[playername]; end
	   if (CN_FData[playername]) then playerdata = CN_FData[playername]; end
	   
	   if (playernotes) then
		  output = playername.." ("..playernotes..")";
		  if (playerdata) then
			 output = output.." "..playerdata;
		  end
		  output = output.." "..CN_TXT.sys_goneoffline;
	   end
   	end

	-- Hplayer:name[<name>] has come online. (sys_comeonline)
	if (string.find(msg, CN_TXT.sys_comeonline)) then
		CN_Debug(">"..msg.."<");
		-- sometimes online has a [<playername>] and sometimes it doesn't (guild).
		if (string.find(msg,"|")) then
			playername = string.sub (msg, string.find(msg, ":", 1, true)+1 )
			playername = string.sub (playername, 1 , string.find(playername, "|", 1, true)-1 )
		else
			playername = string.sub(msg, 2, string.find(msg, "]")-1)
		end
		CN_Debug("<"..playername..">");

		   
	   if (CN_GNotes[playername]) then playernotes = CN_GNotes[playername]; end
	   if (CN_FNotes[playername]) then playernotes = CN_FNotes[playername]; end
	   if (CN_Notes[playername]) then playernotes = CN_Notes[playername]; end
	   
	   if (CN_GData[playername]) then playerdata = CN_GData[playername]; end
	   if (CN_FData[playername]) then playerdata = CN_FData[playername]; end
	   
	   if (playernotes) then
		  output = playername.." ("..playernotes..")";
		  if (playerdata) then
			 output = output.." "..playerdata;
		  end
		  output = output.." "..CN_TXT.sys_comeonline;
	   end
   	end

	-- <name> joins the party. (sys_joinsparty)
	if (string.find(msg, "joins the party")) then
		CN_Debug(">"..msg.."<");
	end
	-- If we have set anything in output, then we know to output our text
	if (output) then
		return false, output, ...
	end
end


-- _02_ OnEvent() Handler
------------------------------------------------------------
function ChatNotes_OnEvent(self, event, arg1, ...) 
	if (event == "ADDON_LOADED") then
		if (arg1 == "ChatNotes") then
			-- TODO output to screen when setting defaults!
			-- Set State Variables
			if CN_State.debug == nil then CN_State.debug = false end
			if CN_State.color == nil then CN_State.color = false end
			if CN_State.enabled == nil then CN_State.enabled = true end
			-- Display Status
			CN_DisplayStatus()
			CN_PanelOptions()
			CN_PanelUpdate()
		end
	elseif (event == "VARIABLES_LOADED") then
		CN_Debug(event.."(START)")
--		UnregisterEvent("VARIABLES_LOADED")
		CN_Debug(event.." (END)")
	elseif (event == "GUILD_ROSTER_UPDATE") then
		CN_GuildList();
	elseif (event == "FRIENDLIST_UPDATE") then
		CN_FriendsList(false);
	end
end


function CN_PanelOptions()
	CN_OptionsHeader = CN_Panel:CreateFontString(nil, "ARTWORK")
	CN_OptionsHeader:SetFontObject(GameFontNormalLarge)
	CN_OptionsHeader:SetPoint("TOPLEFT", 16, -16)
	CN_OptionsHeader:SetText("Chat Notes v1.4")
	
	CN_GeneralHeader = CN_Panel:CreateFontString(nil, "ARTWORK")
	CN_GeneralHeader:SetFontObject(GameFontWhite)
	CN_GeneralHeader:SetPoint("TOPLEFT", CN_OptionsHeader, "BOTTOMLEFT", 0, -6)
	CN_GeneralHeader:SetText("General Options:")

	CN_PanelGuildNotes = CreateFrame("CheckButton", "CN_PanelGuildNotes", CN_Panel, "OptionsCheckButtonTemplate")
	CN_PanelGuildNotes:SetPoint("TOPLEFT", "CN_GeneralHeader", "BOTTOMLEFT", 0, -4)
	CN_PanelGuildNotesText:SetText("Automatically display Guild Notes")

	CN_PanelColor = CreateFrame("CheckButton", "CN_PanelColor", CN_Panel, "OptionsCheckButtonTemplate")
	CN_PanelColor:SetPoint("TOPLEFT", "CN_PanelGuildNotes", "BOTTOMLEFT", 0, -4)
	CN_PanelColorText:SetText("Colorize notes based on where they are set")

end

function CN_PanelUpdate()
	CN_PanelGuildNotes:SetChecked(CN_State.enabled)
	CN_PanelColor:SetChecked(CN_State.color)
end

function CN_PanelOkay()
	CN_State.enabled = CN_PanelGuildNotes:GetChecked()
	CN_State.color = CN_PanelColor:GetChecked()
end

function CN_PanelSettingsDefault()
	-- CN_PanelGuildNotes:SetChecked(CN_State.enabled)

end


function CN_Panel_OnLoad(CN_Panel)
---------
	CN_Panel.name = "Chat Notes"
	CN_Panel.okay = function (self) CN_PanelOkay(); end;
	CN_Panel.default = function (self) CN_PanelSettingsDefault(); CN_PanelUpdate(); end;
	InterfaceOptions_AddCategory(CN_Panel)

end --function


-- _03_ - OnEvent Functions
------------------------------------------------------------

-- Main routine for adding a Note to a specific player name
------------------------------------------------------------
function CN_AddPlayerNote (player, note)
	local previousnote = CN_Notes[player];
	if (previousnote) then
		CN_Notes[player] = note;
		DEFAULT_CHAT_FRAME:AddMessage(CN_HELP_COLOR..CN_TXT.updated..CN_NORMAL_COLOR..string.format(" %s:%s (it was: %s)",player,note,previousnote));
	else
		CN_Notes[player] = note;
		DEFAULT_CHAT_FRAME:AddMessage(string.format(CN_HELP_COLOR..CN_TXT.added..CN_NORMAL_COLOR.." %s:%s",player,note));
	end
end

-- _04_ Chat Window Functions

------------------------
-- _05_ Slash Handler --
------------------------

-- Main Slash Command handler
------------------------------------------------------------
function CN_ParseSlash(msg) 
	local cmd, params = CN_Extract_NextParameter(msg);
	if (cmd == SLASH_ON) then	
		CN_State.enabled = true;
		CN_PanelUpdate();
		CN_DisplayStatus();
	elseif (cmd == SLASH_OFF) then
		CN_State.enabled = false;
		CN_PanelUpdate();
		CN_DisplayStatus();
	elseif (cmd == SLASH_STATUS) then
		CN_DisplayStatus();
	elseif (cmd == SLASH_ADD) then
		if (params) then
			local playername, note = CN_Extract_NextParameter(params);
			CN_AddPlayerNote(CN_MixedCase(playername), note);
		else
			CN_DisplayAddUsage();
		end
	elseif (cmd == SLASH_WHO) then
		if (params) then
			CN_WhoPlayer(params);
		else
			CN_DisplayWhoUsage();
		end
	elseif (cmd == SLASH_COLOR) then
	    CN_State.color = not CN_State.color
	    CN_PanelUpdate();
	    CN_DisplayStatus();
	elseif (cmd == SLASH_FRIENDS) then
		CN_FriendsList(true);
	elseif (cmd == SLASH_GUILD) then
		CN_GuildList(true);
	elseif (cmd == SLASH_DEBUG) then
		CN_State.debug = not CN_State.debug;
		CN_DisplayStatus();
	else 
		--CN_DisplayUsage();
		InterfaceOptionsFrame_OpenToCategory(CN_Panel)
	end
	
end

-- Generic Add command, parses input to ensure we have a name value pair
------------------------------------------------------------
function CN_AddCommand (cmd)
	if (cmd) then
		local playername, note = CN_Extract_NextParameter(cmd);

		-- Normalize the inputed player name
		playername = CN_MixedCase(playername)
		
		if (note) then
			CN_AddPlayerNote (playername, note);
		else
			CN_DisplayAddUsage();
		end
	else
		CN_DisplayUsage();
	end
end

-- /whois handler for quick query of a username
------------------------------------------------------------
function CN_WhoPlayer (player)
	local playernote = nil
	local playerdata = ""

	-- Normalize the inputed player name
	player = CN_MixedCase(player)

	-- Get Player Data from either Friend or Guild
	if (CN_GData[player]) then
		playerdata = CN_GData[player]
	end
	if (CN_FData[player]) then
		playerdata = CN_FData[player]
	end

	if (CN_Notes[player]) then
		CN_Print(CN_HELP_COLOR.."Whois: ["..player.."]: ("..CN_Notes[player]..")")
	elseif (CN_FNotes[player]) then
		CN_Print(CN_HELP_COLOR.."Whois: ["..player.."]: ("..CN_FNotes[player]..")"..playerdata)
	elseif (CN_GNotes[player]) then
		CN_Print(CN_HELP_COLOR.."Whois: ["..player.."]: ("..CN_GNotes[player]..")"..playerdata)
	end		
end

function CN_FriendsList(output)
	local numFriends = GetNumFriends();
--	CN_Debug ("Friends: "..numFriends);
	local numFriendsOnline = 0;
	local name, level, class, zone, connected, status, note
	local friendIndex
	if (numFriends > 0) then
--		CN_List_Friends = {};
		for friendIndex=1, numFriends do
			name, level, class, zone, connected, status, note = GetFriendInfo(friendIndex);
			if (name) then
				-- If we have class info, then we know we got something.
				if (level > 0) then
					if (not zone) then zone="" end
					CN_FData[name]=class.." ("..level..") in "..zone
				end 
				if (note) then
					note = strtrim(note);
					if (note) then
						if (output) then
							CN_Print("["..name.."] ("..note..")");
						end
						CN_FNotes[name]=note;
					else
						if (output) then
							CN_Print("["..name.."]");
						end
						CN_FNotes[name]=nil;
					end
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage("Error: Problem retrieving friend information")
			end
			num=friendIndex;
		end
		if (output) then
			CN_Print("Retrieved data for "..num.." friends")
		end
	else
		CN_Debug("[CN] Friend info unavailable. Please open the friend window once per session.")
	end
end

-- Populate the CN_GNotes database?
----------------------------------
function CN_GuildList(output)
	local numGuild = GetNumGuildMembers();
	local numGuildOnline = 0;
	local name, level, class, zone, connected, status, note
	local guildIndex
	if (numGuild > 0) then
--		CN_Debug ("Guild: "..numGuild);
		for guildIndex=1, numGuild do
			name, rank, rankIndex, level, class, zone, note, officernote, connected = GetGuildRosterInfo(guildIndex);
			if (name) then
				-- If we have class info, then we know we got something.
				if (level > 0) then
					if (not zone) then zone="" end
					CN_GData[name]=class.." ("..level..") in "..zone
				end 
				-- Check it exists, and if so, trim any white space
				if (note) then
					note = strtrim(note);
					if (note) then
						if (output) then
							CN_Print("["..name.."] ("..note..")");
						end
						if (strlen(note) > 0) then
						   CN_GNotes[name]=note;
						else
							CN_GNotes[name]=nil;
						end
					else
						if (output) then
							CN_Print("["..name.."]");
						end
						CN_GNotes[name]=nil;
					end
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage("Error: Problem retrieving guild information")
			end
			num=guildIndex;
		end
		if (output) then
			CN_Print("Retrieved data for "..num.." guild members")
		end
	else
		CN_Debug("[CN] Guild info unavailable. Please open the guild window once per session.")
	end
end

function CN_DumpColor()
FIZ_HELP_COLOUR		= "|cFFFFFF7F"
FIZ_ERROR_COLOUR	= "|cFFFF0000"
FIZ_UNKNOWN_COLOUR	= "|cFF7F7F7F"
FIZ_HOSTILE_COLOUR	= "|cFFCC4C38"
FIZ_NEUTRAL_COLOUR	= "|cFFE5B200"
FIZ_FRIENDLY_COLOUR	= "|cFF009919"
FIZ_NEW_REP_COLOUR	= "|cFF7F7FFF"
FIZ_NEW_STANDING_COLOUR	= "|cFF6060C0"
FIZ_BAG_COLOUR		= "|cFFC0FFC0"
FIZ_BAG_BANK_COLOUR	= "|cFFFFFF7F"
FIZ_QUEST_COLOUR	= "|cFFC0FFC0"
FIZ_HIGHLIGHT_COLOUR    = "|cFF00FF00"
FIZ_QUEST_ACTIVE_COLOUR	= "|cFFFF7F7F"
FIZ_LOWLIGHT_COLOUR	= "|cFFFF3F3F"
FIZ_SUPPRESS_COLOUR	= "|cFF7F7F7F"

    CN_Debug(FIZ_HELP_COLOUR.."FIZ_HELP_COLOUR"..FIZ_ERROR_COLOUR.."FIZ_ERROR_COLOUR"..FIZ_UNKNOWN_COLOUR.."FIZ_UNKNOWN_COLOUR"..FIZ_HOSTILE_COLOUR.."FIZ_HOSTILE_COLOUR"..FIZ_NEUTRAL_COLOUR.."FIZ_NEUTRAL_COLOUR"..FIZ_FRIENDLY_COLOUR.."FIZ_FRIENDLY_COLOUR"..FIZ_NEW_REP_COLOUR.."FIZ_NEW_REP_COLOUR"..FIZ_NEW_STANDING_COLOUR.."FIZ_NEW_STANDING_COLOUR"..FIZ_BAG_COLOUR.."FIZ_BAG_COLOUR"..FIZ_BAG_BANK_COLOUR.."FIZ_BAG_BANK_COLOUR"..FIZ_QUEST_COLOUR.."FIZ_QUEST_COLOUR"..FIZ_HIGHLIGHT_COLOUR.."FIZ_HIGHLIGHT_COLOUR"..FIZ_QUEST_ACTIVE_COLOUR.."FIZ_QUEST_ACTIVE_COLOUR"..FIZ_LOWLIGHT_COLOUR.."FIZ_LOWLIGHT_COLOUR"..FIZ_SUPPRESS_COLOUR.."FIZ_SUPPRESS_COLOUR");
end

-- Handles processing commandline items in single chunks
------------------------------------------------------------
function CN_Extract_NextParameter(msg)
	local params = msg;
	local command = params;
	local index = strfind(command, " ");
	if ( index ) then
		command = strsub(command, 1, index-1);
		params = strsub(params, index+1);
	else
		params = nil;
	end
	return command, params;
end


-----------------------------------
-- _06_ General Helper Functions --
-----------------------------------

------------------------------------------------------------
function CN_Print(msg, forceDefault)
	if not (msg) then return end
		DEFAULT_CHAT_FRAME:AddMessage(msg)
end

function CN_Debug(msg)
	if not (msg) then return end
	if (CN_State.debug) then
		DEFAULT_CHAT_FRAME:AddMessage(msg)
	end
end

function CN_SafeConcat2(str1, str2)
	if str1 and str2 then 
		return str1..str2
	elseif str1 then
		return str1
	elseif str2 then
		return str2
	else
		return nil
	end
end

-- Returns the string in proper Mixed Case... First letter capitalized, the rest lower
function CN_MixedCase(str)
	--return string.upper(string.sub(str,1,1))..string.sub(string.lower(str),2,-1))
	local Mixed = string.upper(str:sub(1,1))..string.sub(str:lower(),2,-1)
	--return string.upper(string.sub(str,1,1))..string.sub(string.lower(str),2,-1))
	return Mixed
end

-----------------------------------
-- _07_ Information
-----------------------------------

------------------------------------------------------------
function CN_About()
	local ver = GetAddOnMetadata("ChatNotes", "Version");
	local date = GetAddOnMetadata("ChatNotes", "X-Date");
	local author = GetAddOnMetadata("ChatNotes", "Author");
	local web = GetAddOnMetadata("ChatNotes", "X-Website");

	if (author ~= nil) then
		CN_Print(CN_NAME.." "..CN_TXT.by.." "..CN_HELP_COLOR..author.."|r", true);
	end
	if (ver ~= nil) then
		CN_Print("  "..CN_TXT.version..": "..CN_HELP_COLOR..ver.."|r", true);
	end
	if (date ~= nil) then
		CN_Print("  "..CN_TXT.date..": "..CN_HELP_COLOR..date.."|r", true);
	end
	if (web ~= nil) then
		CN_Print("  "..CN_TXT.web..": "..CN_HELP_COLOR..web.."|r", true);
	end
end


function CN_DisplayUsage()
	-- CN_Print(" ", true);
	CN_Print(CN_HELP_COLOR..CN_NAME..":|r "..CN_TXT.help, true);
	CN_Print(CN_HELP_COLOR..CN_TXT.usage..":|r "..CN_TOKEN_COLOR..SLASH_ON.."/"..SLASH_OFF..CN_HELP_COLOR.." -- "..CN_TXT.usageonoff, true);
	CN_DisplayAddUsage();
	CN_DisplayWhoUsage();
	CN_Print(CN_HELP_COLOR..CN_TXT.usage..":|r "..CN_TOKEN_COLOR..SLASH_COLOR..CN_HELP_COLOR.." -- "..CN_TXT.usagecolor, true);
	CN_Print(CN_HELP_COLOR..CN_TXT.usage..":|r "..CN_TOKEN_COLOR..SLASH_DEBUG..CN_HELP_COLOR.." -- "..CN_TXT.usagedebug, true);
end

-- DisplayAddUsage
----------------------
function CN_DisplayAddUsage()
	CN_Print(CN_HELP_COLOR..CN_TXT.usage..":|r "..CN_TOKEN_COLOR..SLASH_ADD.." <playername> <note>"..CN_HELP_COLOR.." -- "..CN_TXT.usageadd, true);
end

-- DisplayWhoUsage
function CN_DisplayWhoUsage()
	CN_Print(CN_HELP_COLOR..CN_TXT.usage..":|r "..CN_TOKEN_COLOR..SLASH_WHO.." <playername>"..CN_HELP_COLOR.." -- "..CN_TXT.usagewho, true);
end

-- Display Status
-----------------------
function CN_DisplayStatus()
	message = CN_NAME..": ";
	if (CN_State.enabled) then
		message = message..CN_NORMAL_COLOR..CN_TXT.enabled;
	else
		message = message..CN_ERROR_COLOR..CN_TXT.disabled;
	end
	
	message = message.." "..CN_HELP_COLOR..CN_TXT.colormode..": "
	if (CN_State.color) then		
		message = message..CN_NORMAL_COLOR..CN_TXT.enabled;
	else
		message = message..CN_ERROR_COLOR..CN_TXT.disabled;
	end
		
	if (CN_State.debug) then
		message = message..CN_NORMAL_COLOR.."  ##DEBUG MODE##";
	end
	DEFAULT_CHAT_FRAME:AddMessage(message);
end
